/*
 * File: AR_LibJob.hpp
 * Created: 14.08.2006
 * Last Modified: 23.08.2006
 * Author: Adrian Rospondek
 */


#ifndef AR_LIBJOB_HPP
#define AR_LIBJOB_HPP


#include <string>



struct AR_LibJob;
struct TC_Alignment;
struct TC_ConstraintList;
struct TC_Method;


void AR_submit_lib_job(AR_LibJob *job);
void AR_retrieve_lib_job(AR_LibJob *job);


struct AR_LibJob {
	struct params {
		TC_Method *TCM;
		int seq_c[2]; // currently only pairwise methods are supported
		std::string aln_c;
		TC_ConstraintList *BASE_CL;
	} param;

	struct in_out {
		TC_ConstraintList *CL;
		TC_Alignment *A;
		std::string in, out;
	} io;


	AR_LibJob(): jobid(n_jobs++), status(LJ_OK)
	{
		param.TCM = 0;
		param.seq_c[0] = param.seq_c[1] = -1;
		param.BASE_CL = 0;
		io.CL = 0;
		io.A = 0;
	}

	virtual ~AR_LibJob()
	{
	}

	virtual void submit()
	{
		AR_submit_lib_job(this);
	}

	virtual void retrieve()
	{
		AR_retrieve_lib_job(this);
	}

	enum {
		LJ_OK, LJ_ERROR
	};

	int jobid;
	int status;

	static unsigned int n_jobs;
};



#endif // AR_LIBJOB_HPP
