/***
 *  $Id: JZ_ConstraintList.hpp 706 2006-12-20 18:10:43Z zola $
 **
 *  File: JZ_ConstraintList.hpp
 *  Created: Dec 11, 2006
 *
 *  Department of Electrical & Computer Engineering
 *  Iowa State University of Science & Technology
 *  Ames, IA 50011, USA
 *
 *  Author: Jaroslaw Zola <zola@iastate.edu>
 *  Please see attached LICENSE file.
 */

#ifndef JZ_CONSTRAINT_LIST_HPP
#define JZ_CONSTRAINT_LIST_HPP

#include <algorithm>
#include <iostream>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <MPI_ibuffer.hpp>
#include <MPI_obuffer.hpp>
#include "AR_LibJob.hpp"
#include "TC_Alignment.hpp"
#include "TC_ConstraintList.hpp"
#include "TC_DistanceMatrix.hpp"
#include "TC_Method.hpp"
#include "TC_Sequences.hpp"
#include "TC_Weights.hpp"
#include "config.hpp"
#include "dp_sim.hpp"
#include "evaluate.hpp"
#include "globals.hpp"
#include "input.hpp"
#include "util.hpp"
#include "util_algo.hpp"
#include "util_io.hpp"
#include "util_mem.hpp"
#include "util_mpi.hpp"
#include "util_seq.hpp"
#include "util_str.hpp"

TC_ConstraintList*
JZ_par_compile_constraint_list(TC_ConstraintList* CL,
			       const std::vector<std::string>& in_files,
			       const char* weight, const MPI_Env& mpi_env);

TC_ConstraintList* JZ_re_weight_constraint_list(TC_ConstraintList* CL,
						const TC_Weights *W);

TC_ConstraintList* JZ_weight_constraint_list(TC_ConstraintList* CL,
					     const char *seq_weight,
					     const MPI_Env& mpi_env);

void broadcast_DM(TC_ConstraintList* CL, const MPI_Env& mpi_env);

#endif // JZ_CONSTRAINT_LIST_HPP
