/*
 * File: TC_DistanceMatrix.hpp
 * Created: 06.06.2006
 * Last Modified: 23.08.2006
 * Author: Adrian Rospondek
 */


#ifndef TC_DISTANCEMATRIX_HPP
#define TC_DISTANCEMATRIX_HPP


#include <vector>



class MPI_Env;
struct AR_node_time;
struct TC_Alignment;
struct TC_ConstraintList;


struct TC_DistanceMatrix {
	char mode[100];
	int **similarity_matrix;
	int **distance_matrix;
	int **score_similarity_matrix;
};



TC_DistanceMatrix *AR_declare_distance_matrix(const int size);
TC_DistanceMatrix *TC_duplicate_distance_matrix(const TC_DistanceMatrix *inDM);
void TC_free_distance_matrix(TC_DistanceMatrix *DM);

TC_DistanceMatrix *AR_par_compute_distance_matrix(const TC_ConstraintList *CL, const char *in_mode,
		const MPI_Env &mpi_env, std::vector<AR_node_time> &times);

int **TC_get_sim_aln_array(const TC_Alignment *A, const char *mode);
int **TC_get_dist_aln_array(const TC_Alignment *A, const char *mode);
int **TC_sim_array2dist_array(int **p, int max);



#endif // TC_DISTANCEMATRIX_HPP
