/*
 * File: TC_Templates.hpp
 * Created: 06.06.2006
 * Last Modified: 16.09.2006
 * Author: Adrian Rospondek
 */


#ifndef TC_TEMPLATES_HPP
#define TC_TEMPLATES_HPP


#include <iostream>



struct TC_Alignment;
struct TC_Sequences;


struct TC_X_template {
	char seq_name[100];
	char template_type[5];
	char template_name[100];
	char template_file[100];
	union {
		char pdb_id[5];
		TC_Sequences *S;
		TC_Alignment *A;
	};
};


struct TC_Templates {
	char seq_type[10];
	TC_X_template *G;
	TC_X_template *P;
	TC_X_template *R;
};



TC_X_template *TC_fill_G_template(const char *name, const char *templ, TC_Sequences *S);
TC_X_template *TC_fill_P_template(const char *name, const char *templ);
TC_X_template *AR_prepare_P_template(const char *name, const char *templ);
void AR_fill_P_template(TC_X_template *P, const char *file_name);
TC_X_template *TC_fill_R_template(const char *name, const char *templ, TC_Sequences *S);

std::ostream &TC_display_X_template(TC_X_template *X, std::ostream &out);

const char *TC_template_type2type_name(const char *type);



#endif // TC_TEMPLATES_HPP
