/*
 * File: TC_Weights.hpp
 * Created: 06.06.2006
 * Last Modified: 24.08.2006
 * Author: Adrian Rospondek
 */


#ifndef TC_WEIGHTS_HPP
#define TC_WEIGHTS_HPP


#include <iostream>



struct TC_ConstraintList;


struct TC_Weights {
	char *mode;
	char *comments;
	int nseq;
	char **seq_name;
	float **PW_SD;
	float **PW_ID;
	float *SEQ_W;
};



TC_Weights *TC_declare_weights(int nseq);
TC_Weights *TC_duplicate_weights(const TC_Weights *W);
TC_Weights *TC_free_weights(TC_Weights *W);

TC_Weights *TC_compute_tcoffee_weight(const TC_ConstraintList * CL);

std::ostream &TC_display_weights(const TC_Weights *W, std::ostream &out);



#endif // TC_WEIGHTS_HPP
