/*
 * File: TC_tree.hpp
 * Created: 06.06.2006
 * Last Modified: 25.08.2006
 * Author: Adrian Rospondek
 */


#ifndef TC_TREE_HPP
#define TC_TREE_HPP



#define NODE 0
#define LEAF 1
#define LEFT 1
#define RIGHT 2



struct TC_Alignment;
struct TC_ConstraintList;
struct TC_Sequences;


struct TC_tree_node {
	TC_tree_node *parent;
	TC_tree_node *left;
	TC_tree_node *right;
	TC_tree_node *bot;
	int visited;
	char *name;
	int isseq;
	int seq;
	int maxnseq;
	int nseq;
	int *lseq;
	int *lseq2;
	float dist;
	float bootstrap;
	float dp;
	int order;
	int leaf; // Number of leave below the considered node
	int node; // Number of nodes below the considered node
	int group;
	float score;
};
typedef TC_tree_node* TC_NT_node;



TC_NT_node TC_declare_tree_node(int nseq);
void TC_create_tree_node(TC_NT_node pptr, TC_NT_node parent);

TC_NT_node TC_insert_tree_node(TC_NT_node pptr);
void TC_set_info(TC_NT_node p, TC_NT_node parent, int pleaf, const char *pname, float pdist, float bootstrap);

TC_NT_node** TC_make_tree(TC_ConstraintList *CL, TC_Sequences *S, const char *tree_file);

TC_NT_node TC_reroot(TC_NT_node ptree, int nseq, int ntotal, TC_NT_node **lu);



#endif // TC_TREE_HPP
