/*
 * File: dp_drivers.hpp
 * Created: 06.06.2006
 * Last Modified: 23.08.2006
 * Author: Adrian Rospondek
 */


#ifndef DP_DRIVERS_HPP
#define DP_DRIVERS_HPP


#include "TC_tree.hpp"



#define LOCAL 1
#define GLOBAL 2
#define LALIGN 3
#define MOCCA 4



struct TC_Alignment;
struct TC_ConstraintList;


typedef int (*TC_pw_func_type)(TC_Alignment *, int *, int **, TC_ConstraintList *);



TC_Alignment *TC_align_two_sequences(const char *seq1, const char *seq2, const char *in_matrix,
		int gop, int gep, const char *in_align_mode);
void TC_toggle_case_in_align_two_sequences(int value);
TC_Alignment *TC_align_two_aln(TC_Alignment *A1, TC_Alignment *A2, const char *in_matrix, int gop,
		int gep, const char *in_align_mode);

int TC_pair_wise(TC_Alignment *A, int *ns, int **l_s, TC_ConstraintList *CL);
TC_pw_func_type TC_get_pair_wise_function(TC_pw_func_type pw, char *dp_mode, int *glocal);

TC_NT_node *TC_tree_aln(TC_NT_node LT, TC_NT_node RT, TC_Alignment *A, int nseq, TC_ConstraintList *CL);

TC_NT_node* AR_seq_tree_aln(TC_NT_node** T, TC_Alignment*& A,
			    TC_ConstraintList*& CL, const char* seq_weight);

#endif // DP_DRIVERS_HPP
