/*
 * File: output.hpp
 * Created: 06.06.2006
 * Last Modified: 23.08.2006
 * Author: Adrian Rospondek
 */


#ifndef OUTPUT_HPP
#define OUTPUT_HPP



struct TC_Alignment;
struct TC_Sequences;



int TC_is_out_format_list(const char *name);

void AR_main_output_aln(TC_Alignment *A, const char *format, const char *fname);
void AR_output_tc_aln(const char *fname, TC_Alignment *A);
void TC_output_clustal_aln(const char *fname, TC_Alignment *A);
void TC_output_fasta_aln(const char *fname, const TC_Alignment *A);
void TC_output_pir_aln(const char *fname, const TC_Alignment *A);

void TC_output_fasta_seq(const char *fname, const TC_Alignment *A);
const char *TC_output_fasta_seqX(const char *name, const char *mode, const TC_Sequences *S,
		const TC_Alignment *A, int i);

FILE *TC_save_constraint_list(const TC_ConstraintList *CL, const char *fname, FILE *fp,
		const char *mode, const TC_Sequences *S);

int TC_output_seq_weights(const TC_Weights *W, const char *wfile);



#endif // OUTPUT_HPP
