/*
 * File: perl_scripts.hpp
 * Created: 06.06.2006
 * Last Modified: 11.09.2006
 * Author: Adrian Rospondek
 */


#ifndef PERL_SCRIPTS_HPP
#define PERL_SCRIPTS_HPP


#define PERL_HEADER "#!/usr/bin/env perl"



static const char *PerlScriptName[] = {
	"fugue_client",
	"msf_aln2fasta_aln"
};


static const char *PerlScriptFile[] = {
	"$argc = $#ARGV + 1;\n\
\
for ($i = 0; $i < $argc; ++$i) {\n\
	$v = $ARGV[$i];\n\
	if ($v eq \"-pdb\") {\n\
		$pdb_name = $ARGV[++$i];\n\
	}\n\
	elsif ($v eq \"-pep\") {\n\
		$pep_file = $ARGV[++$i];\n\
	}\n\
}\n\
\
$fugue_url = \"http://www-cryst.bioc.cam.ac.uk/cgi-bin/cgiwrap/kenji/fugue/align.cgi?structure=PDB&SEQUENCE=SEQ&.submit=\";\n\
$aln_url = \"http://www-cryst.bioc.cam.ac.uk\";\n\
\
\
$pdb_name = `extract_pdb -get_fugue_name $pdb_name`;\n\
chop($pdb_name);\n\
\
if ($pdb_name =~ /extract_pdb: No result/) {\n\
	exit(EXIT_FAILURE);\n\
}\n\
\
open(F, $pep_file);\n\
while (<F>) {\n\
	if (/\\>(.*)/) {\n\
		$seq_name = $1;\n\
	}\n\
	else {\n\
		chop($_);\n\
		$pep = $pep.$_;\n\
	}\n\
}\n\
close(F);\n\
\
$fugue_url =~ s/\\=PDB/\\=$pdb_name/;\n\
$fugue_url =~ s/\\=SEQ/\\=%3E$seq_name%0D%0A$pep%0D%0A/;\n\
\
$tmp_file = \"fugue_client.$$.tmp\";\n\
\
$command = \"wget \\'$fugue_url\\' -O $tmp_file -o /dev/null\";\n\
system($command);\n\
\
open(F, $tmp_file);\n\
while (<F>) {\n\
	last if (/\\.ali/);\n\
}\n\
/\\<a href=\\\"(.*\\.ali[^>]*)\\\"\\>/;\n\
$aln_url .= $1;\n\
\
close(F);\n\
unlink($tmp_file);\n\
\
$command = \"wget \\'$aln_url\\' -O $tmp_file -o /dev/null\";\n\
system($command);\n\
\
open(F, $tmp_file);\n\
while (<F>) {\n\
	s/^>P1;/>/;\n\
	s/\\*//;\n\
	next if (/structure/);\n\
	next if (/sequence:/);\n\
	next if (/^ *$/);\n\
	print $_;\n\
}\n\
close(F);\n\
unlink($tmp_file);",

	"$query_start = -1;\n\
$query_end = -1;\n\
\
while (<>) {\n\
	if (/\\/\\//) {\n\
		$in_aln = 1;\n\
	}\n\
	elsif ($in_aln && /(\\S+)\\s+(.*)/) {\n\
		$name = $1;\n\
		$seq = $2;\n\
		$seq =~ s/\\s//g;\n\
		$seq =~ s/\\~/\\-/g;\n\
		$seq =~ s/\\./\\-/g;\n\
		if ($list{$n}{'name'} && $list{$n}{'name'} ne $name) {\n\
			print \"$list{$n}{'name'} Vs $name\";\n\
			exit(EXIT_FAILURE);\n\
		}\n\
		else {\n\
			$list{$n}{'name'}= $name;\n\
		}\n\
		$list{$n}{'seq'} = $list{$n}{'seq'}.$seq;\n\
		$nseq = ++$n;\n\
	}\n\
	else {\n\
		$n = 0;\n\
	}\n\
}\n\
\
for ($a = 0; $a < $nseq; $a++) {\n\
	print \">$list{$a}{'name'}\\n$list{$a}{'seq'}\\n\";\n\
}"
};



#endif // PERL_SCRIPTS_HPP
