/*
 * File: util.hpp
 * Created: 06.06.2006
 * Last Modified: 13.09.2006
 * Author: Adrian Rospondek
 */


#ifndef UTIL_HPP
#define UTIL_HPP


#include <iostream>
#include <string>
#include <sys/time.h>



class MPI_Env;

extern std::string g_cache;



char **AR_app_init(char **in_argv, int *in_argc, const MPI_Env &mpi_env);

const std::string &AR_prepare_cache(const char *mode);
inline const std::string &AR_get_cache_dir()
{
	return g_cache;
}

int AR_get_cl_param(int argc, char **argv, bool &ok, const char *para_name, int *set_flag, const char *type,
		int optional, int max_n_val, const char *usage, ...);

std::ostream &AR_print_command_line(std::ostream &out, const char *comment);
std::ostream &AR_print_cpu_usage(std::ostream &out, const char *comment);
std::ostream &AR_display_output_filename(std::ostream &out, const char *type, const char *format, const char *name,
		int check_output);

int TC_vsrand(int val);
int TC_get_time();
inline double AR_get_time()
{
	timeval t;

	gettimeofday(&t, 0);
	return t.tv_sec + (0.000001 * t.tv_usec);
}
int TC_mysystem(const char *cmd);

char **TC_clean_seq_names(char **name, int n, int mode);



#endif // UTIL_HPP
