/*
 * File: util_hasch.hpp
 * Created: 06.06.2006
 * Last Modified: 23.08.2006
 * Author: Adrian Rospondek
 */


#ifndef UTIL_HASCH_HPP
#define UTIL_HASCH_HPP



#define FIND 0
#define ADD 1
#define REMOVE 2
#define DECLARE 3
#define MARK 4
#define UNMARK 5
#define FREE 6
#define FREE_STACK 7
#define FREE_ALL 8
#define FREE_MARK 9
#define INFO 10



typedef struct TC_hasch_data *(*TC_declare_hasch_func_type)(struct TC_hasch_entry *);
typedef struct TC_hasch_data *(*TC_free_hasch_func_type)(struct TC_hasch_data *);


struct TC_hasch_data {
	int *list;
};


struct TC_hasch_entry {
	int tag;
	int k;
	TC_hasch_data *data;
	TC_declare_hasch_func_type declare_data;
	TC_free_hasch_func_type free_data;
	TC_hasch_entry *n, *p;
};


struct TC_hasch_t {
	int ne;
	TC_hasch_entry **p;
};


struct TC_char_node {
	int key;
	TC_char_node **c;
};



TC_hasch_t *TC_hcreate(int n_elements, TC_declare_hasch_func_type declare_data,
		TC_free_hasch_func_type free_data);
TC_hasch_t *TC_hdestroy(TC_hasch_t *T, TC_declare_hasch_func_type declare_data,
		TC_free_hasch_func_type free_data);

TC_hasch_entry *TC_hsearch(TC_hasch_t *T, int k, int action, TC_declare_hasch_func_type declare_data,
		TC_free_hasch_func_type free_data);

int TC_string2key(const char *s, TC_char_node *n);



#endif // UTIL_HASCH_HPP
