/*
 * File: util_io.hpp
 * Created: 06.06.2006
 * Last Modified: 13.09.2006
 * Author: Adrian Rospondek
 */


#ifndef UTIL_IO_HPP
#define UTIL_IO_HPP


#include <string>
#include <stdio.h>



struct TC_fname {
	char *path;
	char *name;
	char *suffix;
};



char *AR_check_file_exists(const std::string &fname);

bool AR_mkdir(const std::string &dir_in);
FILE *TC_vfopen(const char *name_in, const char *mode);
int TC_vfclose(FILE *fp);
void TC_vremove(const char *s);
char *TC_add2file2remove_list(const char *name);
void TC_rm_tmp_files();

char *AR_tmpname();
int TC_filename_is_special(const char *fname);
char *TC_path2filename(const char *array);
TC_fname *TC_parse_fname(const char *array);

char **TC_file2lines(const char *name);

FILE *TC_find_token_in_file(const char *fname, FILE *fp, const char *token);
FILE *TC_find_token_in_file_nlines(const char *fname, FILE *fp, const char *token, int n_line);
int TC_token_is_in_file(const char *fname, const char *token);

int TC_count_n_char_in_file(const char *name);
int TC_count_n_char_x_in_file(const char *name, const char x);
int TC_measure_longest_line_in_file(const char *name);

FILE *TC_skip_space(FILE *fp);
FILE *TC_skip_commentary_line_in_file(const char com, FILE *fp);
char *TC_strip_file_from_comments(const char *com, const char *in_file);

void AR_write_file(const std::string &name, const char *buf, const int size);
char *AR_read_file(const std::string &name, int &size);



#endif // UTIL_IO_HPP
