/*
 * File: util_mem.hpp
 * Created: 06.06.2006
 * Last Modified: 12.09.2006
 * Author: Adrian Rospondek
 */


#ifndef UTIL_MEM_HPP
#define UTIL_MEM_HPP


#include <iostream>
#include <stddef.h>



void *AR_allocate(int nobj, size_t obj_size);
void *AR_reallocate(void *ptr, int nobj, size_t obj_size);
void AR_free(void *ptr);
void AR_free_all();

void *TC_declare_arrayN(int ndim, size_t size, ...);
void *TC_realloc_arrayN(int ndim, void *main_array, size_t size, ...);
void TC_free_arrayN(void *p, int n);


char **TC_declare_char(int first, int second);
short int **TC_declare_short_int(int first, int second);
int **TC_declare_int(int first, int second);
float **TC_declare_float(int first, int second);
double **TC_declare_double(int first, int second);

char **TC_realloc_char(char **array, int first, int second, int ext1, int ext2);
short int **TC_realloc_short_int(short int **array, int first, int second, int ext1, int ext2);
int **TC_realloc_int(int **array, int first, int second, int ext1, int ext2);

char **TC_new_realloc_char(char **array, int ext1, int ext2);
int **TC_new_realloc_int(int **array, int ext1, int ext2);
float **TC_new_realloc_float(float **array, int ext1, int ext2);
double **TC_new_realloc_double(double **array, int ext1, int ext2);

void TC_free_char(char **array);
void TC_free_short_int(short int **array);
void TC_free_int(int **array);
void TC_free_float(float **array);
void TC_free_double(double **array);


int TC_read_array_size(void *array, size_t size);


int *TC_ga_memcpy_int(const int *array1, int *array2, int n);
float *TC_ga_memcpy_float(const float *array1, float *array2, int n);
double *TC_ga_memcpy_double(const double *array1, double *array2, int n);

char **TC_duplicate_char(char **array, int len, int field);
char *TC_duplicate_string(const char *string);
int **TC_duplicate_int(int **array, int len, int field);
float **TC_duplicate_float(float **array, int len, int field);
double **TC_duplicate_double(double **array, int len, int field);

char **TC_copy_char(char **array1, char **array2, int len, int number_field);
int **TC_copy_int(int **array1, int **array2, int len, int number_field);
float **TC_copy_float(float **array1, float **array2, int len, int number_field);
double **TC_copy_double(double **array1, double **array2, int len, int number_field);


std::ostream &AR_print_mem_usage(std::ostream &out, const char *comment);



#endif // UTIL_MEM_HPP
