/*
 * File: util_pdb.hpp
 * Created: 18.06.2006
 * Last Modified: 23.08.2006
 * Author: Adrian Rospondek
 */


#ifndef UTIL_PDB_HPP
#define UTIL_PDB_HPP


#include <string>
#include <vector>



enum PDB_LOCATION {
	NOT_PDB,
	LOCAL_PDB,
	REMOTE_PDB
};


struct AR_pdb_coords {
	int start, end;
};


struct AR_pdb_chain {
	std::string pdb_id;
	AR_pdb_coords coords;
};



bool AR_parse_pdb_list(char *pdb_list[], int n_pdb, std::vector<AR_pdb_chain *> &out_list);
int AR_check_pdb_location(std::string &pdb_id);
std::string AR_download_pdb(const std::string &pdb_id);
std::string AR_extract_pdb(const std::string &pdb_file, const int start, const int end);

int AR_begin_mt_download_pdb(const std::vector<std::string> &pdb_list, const int max_n_thr);
int AR_end_mt_download_pdb(std::vector<std::string> &out_list);



#endif // UTIL_PDB_HPP
