/*
 * File: util_seq.hpp
 * Created: 06.06.2006
 * Last Modified: 23.08.2006
 * Author: Adrian Rospondek
 */


#ifndef UTIL_SEQ_HPP
#define UTIL_SEQ_HPP



void TC_ungap(char *seq);
char **TC_ungap_array(char **array, int n);
char *TC_thread_aa_seq_on_dna_seq(const char *s);
int TC_translate_dna_codon(const char *sequence, char stop);

char *TC_get_alphabet(const char *seq, char *alphabet);
char *TC_get_string_type(const char *S);
int TC_is_aa(char x);
int TC_is_dna(char x);
int TC_is_gap(char x);
int *TC_seq2inv_pos(const char *seq);

int TC_generic_get_seq_sim(const char *seq1, const char *seq2, int *cache, const char *mode);
int TC_get_seq_sim(const char *string1, const char *string2, const char *ignore, const char *mode);
int *TC_get_seq_winsim(const char *string1, const char *string2, const char *ignore, const char *mode,
		int *w);
float TC_get_seq_fsim(const char *string1, const char *string2, const char *ignore,
		const char *similarity_set, int **matrix, int MODE);

char **TC_make_group_aa(int *ngroup, const char *mode);
int TC_is_in_same_group_aa(char r1, char r2, int n_group, char **gl, const char *mode);



#endif // UTIL_SEQ_HPP
