/*
 * File: util_str.hpp
 * Created: 06.06.2006
 * Last Modified: 13.09.2006
 * Author: Adrian Rospondek
 */


#ifndef UTIL_STR_HPP
#define UTIL_STR_HPP



char *TC_generate_string(int len, char x);

int TC_vstrcmp(const char *s1, const char *s2);
int TC_vstrncmp(const char *s1, const char *s2, int n);
int TC_case_insensitive_strcmp(const char *s1, const char *s2);
char *TC_after_strstr(const char *string, const char *token);

char *TC_upper_string(char *string);
char *TC_lower_string(char *string);
char *TC_substitute(char *string_in, const char *t, const char *r);
char **TC_clean_string(int n, char **string);
void TC_translate_name(char *name);
void TC_remove_charset(char *seq, const char *set);

char **TC_string2list(const char *string);
char **TC_string2list2(const char *string, const char *separators);
int *TC_string2num_list(const char *string);
int *TC_string2num_list2(const char *string, const char *separators);


void TC_string_array_upper(char **string, int n);
void TC_string_array_lower(char **string, int n);
char **TC_padd_strings(char **string, int n, char pad);


char **TC_break_list(char **argv, int *argc, const char *separators);
char **TC_merge_list(char **argv, int *argc);
char **TC_get_list_of_tokens(const char *string, const char *separators, int *n_tokens);
char **TC_push_string(const char *val, char **stack, int *nval, int position);

int TC_name_is_in_list(const char *name, char **name_list, int n_name, int len);
int TC_is_in_set(char c, const char *list);
char *TC_check_list_for_dup(char **list, const int ne);
int TC_get_longest_string(char **array, int n, int *len, int *index);
int TC_get_shortest_string(char **array, int n, int *len, int *index);


int TC_is_alpha_line(const char *buf);
int TC_is_blank(const char *buf);
int TC_is_number(const char *num);



#endif // UTIL_STR_HPP
