/*
 * File: AR_LibJob.cpp
 * Created: 14.08.2006
 * Last Modified: 27.08.2006
 * Author: Adrian Rospondek
 */


#include <iostream>
#include "AR_LibJob.hpp"
#include "TC_Method.hpp"
#include "globals.hpp"
#include "input.hpp"
#include "methods.hpp"



unsigned int AR_LibJob::n_jobs = 0;


void AR_submit_lib_job(AR_LibJob *job)
{
	TC_Method *M = job->param.TCM;

	if (TC_strm2(M->out_mode, "fA", "fL")) {
		job->io.CL = AR_seq2list(job);

		if (!job->io.CL) {
			std::cerr << '\n' << PROGRAM << ": Method '" << M->executable << "' failed.\n";
			job->status = AR_LibJob::LJ_ERROR;
		}
	}
	else {
		std::cerr << '\n' << PROGRAM << ": ERROR: Method '" << M->executable << "' has unknown out mode ("
				  << M->out_mode << ").\n";
	}
}

void AR_retrieve_lib_job(AR_LibJob *job)
{
	TC_Method *M = job->param.TCM;

	if (job->status == AR_LibJob::LJ_OK) {
		if (TC_strm2(M->out_mode, "aln", "A"))
			job->io.CL = TC_read_constraint_list(job->io.CL, job->io.out.c_str(), "aln", M->weight);
		else if (TC_strm2(M->out_mode, "lib", "L"))
			job->io.CL = TC_fast_read_constraint_list_file(job->io.CL, job->io.out.c_str());
	}
}
